.386
.model flat, stdcall  ;32 bit memory model
option casemap :none  ;case sensitive



; ##########################################
; PROTO's for Graphics.lib

ConvertToDIB32			PROTO	:DWORD
SaveDIB32				PROTO	:DWORD,:DWORD
DIBSaveBitmap			PROTO	:DWORD,:DWORD,:DWORD
;DIBGetColors			PROTO	:DWORD,:DWORD,:DWORD
;EnumColors				PROTO	:DWORD,:DWORD,:DWORD,:DWORD,:DWORD
;	Parameters 
;		hBmp = Handle to a 32bit DIB section
;		hFile = Handle to an open file object with write access
;		cClrBits = Bit depth of the saved image, valid values are 2,4,8,24

includelib C:\RadASM\GoAsm\Projects\Graphics\Graphics.lib

include windows.inc
include kernel32.inc
include user32.inc
include shell32.inc
include gdi32.inc
include oleaut32.inc
include ole32.inc
include MASM32.INC

includelib kernel32.lib
includelib user32.lib
includelib shell32.lib
includelib gdi32.lib
includelib oleaut32.lib
includelib ole32.lib
includelib masm32.lib

include \RadASM\masm\inc\debug.inc
includelib \RadASM\masm\lib\debug.lib

DBGWIN_DEBUG_ON = 1 ; include debug info into the program
DBGWIN_EXT_INFO = 1 ; include extra debug info into the program

.DATA
	hInst	DD	?
	hBmp	DD	?
	hFile	DD	?
	JpgFile	DB	"C:\RadASM\Masm\Projects\TestBitmap\sincity.jpg",0
	OutFile	DB	"TestMASM.bmp",0

.CODE
Start:
	invoke CoInitialize, 0

	invoke BitmapFromFile, offset JpgFile
	test eax,eax
	jz ErrorBmp
	
	invoke ConvertToDIB32, eax
	mov [hBmp],eax
	
	invoke CreateFile,offset OutFile,GENERIC_WRITE,NULL,NULL,CREATE_ALWAYS,NULL,NULL
	mov [hFile], eax
	
	invoke SaveDIB32, [hBmp], [hFile]
	
	invoke CloseHandle, [hFile]
	invoke DeleteObject, [hBmp]
	
	invoke CoUninitialize
	xor eax,eax
	ret
	
	ErrorBmp:
	invoke CoUninitialize
	xor eax,eax
	dec eax
	ret

end Start
